Bug 1262644 - Review Request: python-Pyped - Replace sed/grep/cut/awk by letting you execute Python one-liners
Review Request: python-Pyped - Replace sed/grep/cut/awk by letting you execut...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Julien Enselme
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-09-13 16:05 EDT by René Ribaud
Modified: 2015-11-30 18:22 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-11-30 16:21:36 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jujens: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description René Ribaud 2015-09-13 16:05:07 EDT
Spec URL: http://uggla.free.fr/rpmbuild/SPECS/python-Pyped.spec
SRPM URL: http://uggla.free.fr/rpmbuild/SRPMS/python-Pyped-1.4-1.fc22.src.rpm
Description:
Pyped is a command-line tool that let you process another command
output with a Python one-liner like Perl or AWK.
Fedora Account System Username: uggla
Comment 1 Ilya Gradina 2015-09-19 08:17:23 EDT
This is an unofficial review of the package.
some notes:
1) no tests
2) errors: "non-executable-script /usr/lib/python2.7/site-packages/pyped.py 644 /usr/bin/env" also error for python3.*.
3) no-manual-page-for-binary pyp

---------------------------------------------------------------------------
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 2 files have unknown license. Detailed
     output of licensecheck in /home/ilgrad/1262644-python-
     Pyped/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[ ]: Python eggs must not download any dependencies during the build
     process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-Pyped , python3-Pyped
[ ]: Package functions as described.
[x]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.2.13 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.13
INFO: Mock Version: 1.2.13
Finish: chroot init
INFO: installing package(s): /home/ilgrad/1262644-python-Pyped/results/python2-Pyped-1.4-1.fc24.noarch.rpm /home/ilgrad/1262644-python-Pyped/results/python3-Pyped-1.4-1.fc24.noarch.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 24 install /home/ilgrad/1262644-python-Pyped/results/python2-Pyped-1.4-1.fc24.noarch.rpm /home/ilgrad/1262644-python-Pyped/results/python3-Pyped-1.4-1.fc24.noarch.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: python2-Pyped-1.4-1.fc24.noarch.rpm
          python3-Pyped-1.4-1.fc24.noarch.rpm
          python-Pyped-1.4-1.fc24.src.rpm
python2-Pyped.noarch: W: spelling-error Summary(en_US) sed -> tied, ed, seed
python2-Pyped.noarch: W: spelling-error Summary(en_US) awk -> awl, aw, wk
python2-Pyped.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyped.py 644 /usr/bin/env
python2-Pyped.noarch: W: no-manual-page-for-binary pyp
python3-Pyped.noarch: W: spelling-error Summary(en_US) sed -> tied, ed, seed
python3-Pyped.noarch: W: spelling-error Summary(en_US) awk -> awl, aw, wk
python3-Pyped.noarch: E: non-executable-script /usr/lib/python3.4/site-packages/pyped.py 644 /usr/bin/env
python3-Pyped.noarch: W: no-manual-page-for-binary pyp
python-Pyped.src: W: spelling-error Summary(en_US) sed -> tied, ed, seed
python-Pyped.src: W: spelling-error Summary(en_US) awk -> awl, aw, wk
3 packages and 0 specfiles checked; 2 errors, 8 warnings.




Requires
--------
python2-Pyped (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python-arrow
    python-path
    python-requests
    python-six
    python2-minibelt

python3-Pyped (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3-arrow
    python3-minibelt
    python3-path
    python3-requests
    python3-six



Provides
--------
python2-Pyped:
    python-Pyped
    python2-Pyped

python3-Pyped:
    python3-Pyped
Comment 2 René Ribaud 2015-09-20 07:50:39 EDT
Hello,

Thanks for reviewing the pkg.
Here is a couple of answers about your comments.

1) no tests
The upstream package is not provided with unitary tests. I kept the %check section in the spec file to remember me to implement that as soon as upstream will implement some of them.

2) errors: "non-executable-script /usr/lib/python2.7/site-packages/pyped.py 644 /usr/bin/env" also error for python3.*.
Unfortunately, I think I submitted this package a bit too early. You can notice that the package depends of minibelt, which is not in the released yet and prevent the package installation.
I have a request for it : https://bugzilla.redhat.com/show_bug.cgi?id=1262643


3) no-manual-page-for-binary pyp
Unless if I'm wrong there is no manual page provided by upstream yet.

So I think this pkg is on old until, minibelt will be integrated into Fedora.
Comment 3 Julien Enselme 2015-10-13 17:06:13 EDT
- I guess you intended to use the %sum variable
- Python3 by default https://fedoraproject.org/wiki/Packaging:Python#Avoiding_collisions_between_the_python_2_and_python_3_stacks
- Not sure if your patch is useful
- To get rid of the E: non-executable-script /usr/lib/python3.4/site-packages/pyped.py 644 /usr/bin/env you should remove the shebang from pyped.py. The typical way to do this is to call sed -i '1{\@^#!/usr/bin/env python@d}' %{buildroot}%{python3_sitearch}/pyped.py in %install (the same for python 2). I will wait for this to be fixed before approving the package.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[X]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[X]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 2 files have unknown license. Detailed
     output of licensecheck in /tmp/1262644-python-Pyped/licensecheck.txt
[X]: License file installed when any subpackage combination is installed.
[X]: Package contains no bundled libraries without FPC exception.
[X]: Changelog in prescribed format.
[X]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[X]: Package uses nothing in %doc for runtime.
[X]: Package consistently uses macros (instead of hard-coded directory
     names).
[X]: Package is named according to the Package Naming Guidelines.
[X]: Package does not generate any conflict.
[X]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[X]: Requires correct, justified where necessary.
[X]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[X]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[X]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[X]: Python eggs must not download any dependencies during the build
     process.
[X]: A package which is used by another package via an egg interface should
     provide egg info.
[X]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[X]: Final provides and requires are sane (see attachments).
[X]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-Pyped , python3-Pyped
[?]: Package functions as described.
[X]: Latest version is packaged.
[X]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
     
     Not sure that this patch is useful. Not blocking as this works fine with it.
     
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[X]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-Pyped-1.4-1.fc24.noarch.rpm
          python3-Pyped-1.4-1.fc24.noarch.rpm
          python-Pyped-1.4-1.fc24.src.rpm
python2-Pyped.noarch: W: spelling-error Summary(en_US) sed -> tied, ed, seed
python2-Pyped.noarch: W: spelling-error Summary(en_US) awk -> awl, aw, wk
python2-Pyped.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyped.py 644 /usr/bin/env
python2-Pyped.noarch: W: no-manual-page-for-binary pyp
python3-Pyped.noarch: W: spelling-error Summary(en_US) sed -> tied, ed, seed
python3-Pyped.noarch: W: spelling-error Summary(en_US) awk -> awl, aw, wk
python3-Pyped.noarch: E: non-executable-script /usr/lib/python3.4/site-packages/pyped.py 644 /usr/bin/env
python3-Pyped.noarch: W: no-manual-page-for-binary pyp
python-Pyped.src: W: spelling-error Summary(en_US) sed -> tied, ed, seed
python-Pyped.src: W: spelling-error Summary(en_US) awk -> awl, aw, wk
3 packages and 0 specfiles checked; 2 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
python2-Pyped.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/pyped.py 644 /usr/bin/env
python2-Pyped.noarch: W: no-manual-page-for-binary pyp
python3-Pyped.noarch: E: non-executable-script /usr/lib/python3.4/site-packages/pyped.py 644 /usr/bin/env
python3-Pyped.noarch: W: no-manual-page-for-binary pyp
2 packages and 0 specfiles checked; 2 errors, 2 warnings.



Requires
--------
python2-Pyped (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python-arrow
    python-path
    python-requests
    python-six
    python2-minibelt

python3-Pyped (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3-arrow
    python3-minibelt
    python3-path
    python3-requests
    python3-six



Provides
--------
python2-Pyped:
    python-Pyped
    python2-Pyped

python3-Pyped:
    python3-Pyped



Source checksums
----------------
http://pypi.python.org/packages/source/P/Pyped/Pyped-1.4.tar.gz :
  CHECKSUM(SHA256) this package     : ed458cfec5ef48a2cc2266f82f8c2b35efe5f63cd523612acddac953dd26a8d3
  CHECKSUM(SHA256) upstream package : ed458cfec5ef48a2cc2266f82f8c2b35efe5f63cd523612acddac953dd26a8d3


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1262644
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 4 Julien Enselme 2015-10-13 17:19:41 EDT
> - Python3 by default

I hit "save changes" a little fast. You are indeed using python3 by default, but you include the binary twice in python2 package and in python3 package. Since it is design to run with python3, please include it only in the python3 package. I don't think it can work with only the python2 version of the package.

As stated in the guidelines, if the python2 executable behaves differently from the python3 one (which seems likely since it executes python code and python2 and python3 are not entirely compatible) you should provide a pyp-%{python2_version} binary in the python2 package. You can also have a pyp-%{python3_version} symlink to pyp.

To do this, rename the executable `mv %{buildroot}%{_bindir}/pyp %{buildroot}%{_bindir}/pyp-%{python2_version}` before running %py3_install
Comment 5 René Ribaud 2015-11-09 09:46:47 EST
Hello Julien,

>- I guess you intended to use the %sum variable
I used it now.
>- Python3 by default https://fedoraproject.org wiki/Packaging:Python#Avoiding_collisions_between_the_python_2_and_python_3_stacks
Fixed as porposed in the doco. Please tell me if it is fine from your point of view.
>- Not sure if your patch is useful
Yep otherwise I get an error at build step.
>- To get rid of the E: non-executable-script /usr/lib/python3.4/site-packages pyped.py 644 /usr/bin/env you should remove the shebang from pyped.py. The typical way to do this is to call sed -i '1{\@^#!/usr/bin/env python@d}' %{buildroot}%{python3_sitearch}/pyped.py in %install (the same for python 2). I will wait for this to be fixed before approving the package.
I have just made the required file executable as it should be run by the user.

New packages location :
Spec URL: http://uggla.free.fr/rpmbuild/SPECS/python-Pyped.spec
SRPM URL: http://uggla.free.fr/rpmbuild/SRPMS/python-Pyped-1.4-2.fc22.src.rpm
Comment 6 Upstream Release Monitoring 2015-11-09 09:57:50 EST
uggla's scratch build of python-Pyped-1.4-2.fc22.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11756733
Comment 7 Julien Enselme 2015-11-09 16:19:45 EST
I think you should add a line break between each changelog entry to make it more readable.

The Python3 subpackage should have the default executable for 22 and above.

Looks good. Approved.
Comment 8 Gwyn Ciesla 2015-11-10 09:50:21 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/python-Pyped
Comment 9 Fedora Update System 2015-11-19 09:55:02 EST
python-Pyped-1.4-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-c67e5728c9
Comment 10 Fedora Update System 2015-11-19 10:00:50 EST
python-Pyped-1.4-2.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-8068233338
Comment 11 Fedora Update System 2015-11-20 05:21:53 EST
python-Pyped-1.4-2.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update python-Pyped'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-8068233338
Comment 12 Fedora Update System 2015-11-20 06:24:20 EST
python-Pyped-1.4-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update python-Pyped'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-c67e5728c9
Comment 13 Fedora Update System 2015-11-30 16:21:33 EST
python-Pyped-1.4-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 14 Fedora Update System 2015-11-30 18:22:48 EST
python-Pyped-1.4-2.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.